/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jxva.cache;



/**
 *LRU(Least Recently Used)和LFU(Least Frequently Used)
 *LFU-EA(LFU with Exponential Aging)
 * @author  The Jxva Framework Foundation
 * @since   1.0
 * @version 2009-01-22 23:27:29 by Jxva
 */
public interface Cache {
	
	/**
	 * 
	 */
	public void clear();

	/**
	 * 
	 * @param key
	 * @return
	 */
	public boolean containsKey(Object key);
	
	/**
	 * Prepares for shutdown
	 */
	public void dispose();
	
	/**
	 * 
	 * @param key
	 * @return
	 */
	public Object getValue(Object key);
	
	/**
	 * 
	 * @param key
	 * @return
	 */
	public Object getQuietValue(Object key);
	
	/**
	 * 
	 * @param key
	 * @return
	 */
	public Element get(Object key);
	
	/**
	 * without updating hits
	 * @param key
	 * @return
	 */
	public Element getQuiet(final Object key);
		
	/**
	 * 
	 * @return
	 */
	public Object[] getKeys();
	
	/**
	 * 
	 * @return
	 */
	public String getName();

	/**
	 * 
	 * @return
	 */
	public int size();

	/**
	 * 
	 * @param key
	 * @param value
	 */
	public void put(Object key,Object value);
	
	/**
	 * 
	 * @param element
	 */
	public void put(Element element);

	/**
	 * 
	 * @param key
	 * @return
	 */
	public Element remove(Object key);	
	
	/**
	 * 
	 * @return
	 */
	public boolean isEmpty();
}
