/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jxva.cache.strong;

import com.jxva.cache.Cache;
import com.jxva.cache.Element;
import com.jxva.cache.entity.MRUMap;


/**
 * Most Recently Used
 * @author  The Jxva Framework Foundation
 * @since   1.0
 * @version 2009-01-23 11:20:07 by Jxva
 */
public class MRUSoftCache extends AbstractStrongCache {
	private static final long serialVersionUID = 1L;
	
	public MRUSoftCache(String name){
		this(name,DEFAULT_MAX_SIZE);
	}
	
	public MRUSoftCache(String name,int maxSize) {
		this.name=name;
		this.maxSize = maxSize;
		map = new MRUMap<Object,Element>(maxSize);
	}

	public static void main(String[] args) {
        Cache cache = new MRUSoftCache("ddd",4);  
        cache.put(1, "1");  
        cache.put(2, "2");  
        cache.put(3, "3");
        cache.getValue(3);
        cache.put(4, "4");
        cache.getValue(4);
        cache.put(5, "5");  
        

        cache.put(6, "6"); 
        cache.getValue(5);
        cache.put(7, "7");  
        cache.getValue(4);


        cache.put(8, "8");  
        


        cache.put(9, "9");  
        cache.put(10, "10"); 
        cache.put(11, "11"); 
  

        cache.put(12, "12"); 
        cache.put(13, "13"); 

        
        String value = (String)cache.getValue(4);  
        System.out.println(value);  
        System.out.println("Testing ...");  
        
        Object[] keys= cache.getKeys(); 
        System.out.println(keys.length);
        for (Object key:keys) {  
            System.out.println(cache.get(key));  
        } 	 				
	}
}
