/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jxva.cache.weak;

import com.jxva.cache.Cache;


/**
 * @author  The Jxva Framework Foundation
 * @since   1.0
 * @version 2009-01-23 23:30:15 by Jxva
 */
public class WeakTest {

	public static void main(String[] args) {
        demo(new LRUWeakCache("test",5));
	}
	

	
	public static void demo(Cache cache){
		logln(cache.getName()+"--------------------------------");
        cache.put(1, "1");  
        cache.put(2, "2");  
        cache.put(3, "3");  
        cache.put(4, "4");  
        cache.getValue(4);
        cache.put(5, "5");  
        cache.put(6, "6");  
        cache.put(7, "7");  
        cache.getValue(4);
        cache.put(8, "8");  
        cache.put(9, "9");  
 
        log(cache.getValue(4));   
        
        Object[] keys= cache.getKeys(); 
        logln(keys.length);
        for (Object key:keys) {  
        	log(cache.getValue(key));
        	log(cache.containsKey(key)); 
        	log(cache.getKeys().length); 
        	log(cache.getQuiet(key)); 
        	log(cache.remove(key)); 
        	logln(cache.get(key));  
        } 		
	}
	
	public static void log(Object obj){
		System.out.print(obj);
	}
	
	public static void logln(Object obj){
		System.out.println(obj);
	}
}
