/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.jxva.entity;

/**
 * 
 * @author  The Jxva Framework
 * @since   1.0
 * @version 2009-01-12 19:50:42 by Jxva
 */
public class UserAgentAnalyzer {
	
	private String userAgent;
	
	public UserAgentAnalyzer(String userAgent){
		this.userAgent=userAgent;
	}
	
	public String getOs(){
		String os=userAgent;
		if(os.indexOf("NT 5.0")>-1){
			return "Windows 2000";
		}else if(os.indexOf("NT 5.1")>-1){
			return "Windows XP";
		}else if(os.indexOf("NT 5.2")>-1){
			return "Windows 2003";
		}else if(os.indexOf("NT 6.0")>-1){
			return "Windows Vista";
		}else if(os.indexOf("9x")>-1){
			return "Windows Me";
		}else if(os.toLowerCase().indexOf("linux")>-1){
			return "Linux";
		}else if(os.toLowerCase().indexOf("unix")>-1){
			return "Unix";
		}else{
			return "Other";
		}
	}
		
	public String getBrowser(){
		try{
			//Maxthon TencentTraveler TheWorld MyIE2 GreenBrowser
			if(userAgent.indexOf("MSIE")>-1){
				String ie=(userAgent.split(";")[1]).replaceAll("MSIE","IE");
				if(userAgent.toLowerCase().indexOf("maxthon")>-1){
					return "Maxthon for "+ie;
				}else if(userAgent.toLowerCase().indexOf("tencenttraveler")>-1){
					return "TencentTraveler for "+ie;
				}else if(userAgent.toLowerCase().indexOf("theworld")>-1){
					return "TheWorld for "+ie;
				}else if(userAgent.toLowerCase().indexOf("myie2")>-1){
					return "MyIE2 for "+ie;
				}else if(userAgent.toLowerCase().indexOf("greenbrowser")>-1){
					return "GreenBrowser for "+ie;
				}else{
					return ie;
				}
			}else if(userAgent.indexOf("Firefox")>-1){
				return "Firefox "+userAgent.split("Firefox")[1].substring(1);
			}else if(userAgent.indexOf("Opera")>-1){
				return "Opera "+userAgent.split("Opera")[1].split(" ")[0].substring(1);
			}else if(userAgent.indexOf("Chrome")>-1){
				return "Chrome "+userAgent.split("Chrome")[1].split(" ")[0].substring(1);
			}else if(userAgent.indexOf("Safari")>-1){
				return "Safari "+userAgent.split("Safari")[1].substring(1);
			}else if(userAgent.indexOf("Shiretoko")>-1){
				return "Shiretoko "+userAgent.split("Shiretoko")[1].split(" ")[0].substring(1);
			}else if(userAgent.indexOf("Linux")>-1){
				return "Linux";
			}else{
				return "Other";
			}
		}catch(Exception e){
			e.printStackTrace();
			return "Error";
		}
	}
}
