/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jxva.graph;

import com.jxva.graph.strategy.AffineGraph;
import com.jxva.graph.strategy.CompressGraph;
import com.jxva.graph.strategy.FilterGraph;
import com.jxva.graph.strategy.HighQualityGraph;
import com.jxva.graph.strategy.SmoothGraph;


/**
 *
 * @author  The Jxva Framework Foundation
 * @since   1.0
 * @version 2008-11-27 14:38:56 by Jxva
 */
public class GraphFactory {
	
	public static Graph createGraph(){
		return createAffineGraph();
	}
	
	public static Graph createGraph(Graph graph){
		return graph;
	}
	
	public static Graph createHighQualityGraph(){
		return new HighQualityGraph();
	}
	
	public static Graph createFilterGraph(){
		return new FilterGraph();
	}
	
	public static Graph createCompressGraph(){
		return new CompressGraph();
	}
	
	public static Graph createAffineGraph(){
		return new AffineGraph();
	}
	
	public static Graph createSmoothGraph(){
		return new SmoothGraph();
	}
}
