/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.jxva.mvc;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author  The Jxva Framework Foundation
 * @since   1.0
 * @version 2009-04-02 19:06:58 by Jxva
 */
public class ActionContext {
	
	
	private static ThreadLocal<ActionContext> threadLocal=new ThreadLocal<ActionContext>();
	
	private HttpServletRequest request;
	private HttpServletResponse response;
	
	ActionContext initByCoreFilter(HttpServletRequest request,HttpServletResponse response){
		this.request=request;
		this.response=response;
		return this;
	}
	
	static void setContext(ActionContext context) {
		threadLocal.set(context);
	}
	
	static void remove(){
		threadLocal.remove();
	}
	
	public static ActionContext getContext() {
		return threadLocal.get();
	}
	
	public HttpServletRequest getRequest(){
		return request;
	}
	
	public HttpServletResponse getResponse(){
		return response;
	}
	
	public HttpSession getSession(){
		return request.getSession(true);
	}
	
	public HttpCookie getCookie(){
		return new HttpCookie(request,response);
	}
}
