/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.jxva.mvc;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.jxva.entity.Encoding;
import com.jxva.plugin.Plugin;
import com.jxva.plugin.PluginException;

/**
 * framework core filter:plugin initialze,charset code,servlet context initialze
 * @author  The Jxva Framework
 * @since   1.0
 * @version 2008-11-27 09:27:57 by Jxva
 */
public class CoreFilter implements Filter{
	
	private String encoding;
	private ActionContext context;
	
	public void destroy(){
		this.encoding = null;
		new Plugin().destroy();
	}
	
	public void init(FilterConfig filterConfig) throws ServletException {
		encoding =filterConfig.getInitParameter("encoding");
		context=new ActionContext();
		if(encoding==null)encoding=Encoding.UTF_8;
		try {
			new Plugin().initialize();
		} catch (PluginException e) {
			throw new ServletException(e);
		}
	}
	
	public void doFilter(ServletRequest req, ServletResponse resp,FilterChain chain)throws IOException, ServletException {
		try{
			req.setCharacterEncoding(encoding);
			HttpServletRequest request = (HttpServletRequest)req;
			HttpServletResponse response = (HttpServletResponse)resp;
			ActionContext.setContext(context.initByCoreFilter(request, response));
		    chain.doFilter(req,resp);
		}finally{
			ActionContext.remove();
		}
	}
}