
/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
package com.jxva.tag;

import java.lang.reflect.Array;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * <j:present name="var|obj">content</j:present>
 * @author  The Jxva Framework Foundation
 * @since 2006-12-16
 */

public class PresentTag extends TagSupport {
	
	private static final long serialVersionUID = 1L;

	protected String name;

	public void setName(String name) {
		this.name = name;
	}

	public int doStartTag() throws JspException {
		Object obj=TagUtil.getScopeObject(pageContext,name);
		if(obj==null){
			return SKIP_BODY; 
		}else{
			if (obj.getClass().isArray()) {
				if(Array.getLength(obj)==0)return SKIP_BODY;
			} else if (obj instanceof Collection) {
				if(((Collection<?>) obj).isEmpty())return SKIP_BODY;
			} else if (obj instanceof Iterator) {
				if(!((Iterator<?>) obj).hasNext())return SKIP_BODY;
			} else if (obj instanceof Map) {	
				if(((Map<?,?>) obj).isEmpty())return SKIP_BODY;
			} else if (obj instanceof Enumeration) {
				if(!((Enumeration<?>) obj).hasMoreElements())return SKIP_BODY;
			}
			return EVAL_BODY_INCLUDE;
		}
	}

	public int doEndTag() throws JspException {
		return EVAL_PAGE;
	}
}
