/*
 * Copyright @ 2006-2009 by The Jxva Framework Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package license;

import junit.framework.TestCase;

import com.jxva.license.Edition;
import com.jxva.license.License;
import com.jxva.license.LicenseManager;
import com.jxva.util.PathUtil;

/**
 * 
 * @author The Jxva Framework Foundation
 * @since 1.0
 * @version 2008-12-01 15:06:34 by Jxva
 */
public class LicenseTest extends TestCase {
	
	private License license;
	

	public void setUp() {
		LicenseManager manager=LicenseManager.getInstance(PathUtil.getPath(this.getClass())+"license.lic");
		license=manager.getLicense();
	}
	
	public void test() {
		assertTrue(!license.isExpired());
		assertEquals(license.getEdition(),Edition.DEVELOPMENT.getName());
	}
}
